package com.cim.idm.wmspackage.materialpacking.management.data;

import java.sql.Timestamp;

import com.cim.idm.framework.orm.info.DataInfo;
import com.cim.idm.framework.orm.info.KeyMark;
import com.cim.idm.framework.orm.info.access.FieldAccessor;

public class MaterialPackingMultiHoldInfo extends FieldAccessor implements DataInfo<MaterialPackingMultiHoldInfoKey>{
	
	@KeyMark
	private MaterialPackingMultiHoldInfoKey key;
	private String eventComment;
	private String eventName;
	private Timestamp eventTime;
	private String eventUser; 
	
	@Override
	public MaterialPackingMultiHoldInfoKey getKey() {
		return key;
	}

	@Override
	public void setKey(MaterialPackingMultiHoldInfoKey keyInfo) {
		this.key = keyInfo;
		
	}

	public String getEventComment() {
		return eventComment;
	}

	public void setEventComment(String eventComment) {
		this.eventComment = eventComment;
	}

	public String getEventName() {
		return eventName;
	}

	public void setEventName(String eventName) {
		this.eventName = eventName;
	}

	public Timestamp getEventTime() {
		return eventTime;
	}

	public void setEventTime(Timestamp eventTime) {
		this.eventTime = eventTime;
	}

	public String getEventUser() {
		return eventUser;
	}

	public void setEventUser(String eventUser) {
		this.eventUser = eventUser;
	}

}
