package com.cim.idm.constants;


/**
 *******************************************************************************   
 * @ProjectName : MESSolution.Generic 
 * @Package     : com.cim.idm.mesextend.generic.master.PolicyDef.java  
 * @ClassName   : PolicyDef  
 * @Description :    
 * @Author      : ZXY Team.
 * @CreateDate  : 2022-1-30 9:44:25   
 * @UpdateRemark: 
 * @Version     : V1.0
 *******************************************************************************
 */
public interface PolicyDef
{
	//Flag
	public static final String	FLAG_Y = "Y";
	public static final String	FLAG_N = "N";
	public static final String	FLAG_X = "X";
	public static final String  LEGALRECYCLENUM="1";
	public static final String	OK = "OK";
	public static final String	NG = "NG";
	
	public static final String FLAG_YES = "Yes";
	public static final String FLAG_No = "No";
	
	public static final String	Rework_FlowName = "EN/RW Currency";
	
	// Label Type
	public static final String	LabelType_Lot = "Lot";
	public static final String	LabelType_InnerBox = "InnerBox";
	public static final String	LabelType_OuterBox = "OuterBox";
	public static final String	LabelType_Pallet = "Pallet";
	public static final String	LabelType_PalletList = "PalletList";
	public static final String	LabelType_VirtualLot = "VirtualLot";
	public static final String	LabelType_RMAPanel = "RMAPanel";
	public static final String	LabelType_ModuleName = "ModuleName";
	public static final String	LabelType_RMABox = "RMABox";
	public static final String	LabelType_ArriveMaterial = "ArriveMaterial";
	
	// Lot Operation
	public static final String	Operation_Ship = "K9999";
	public static final String	Operation_Packing = "K1007";
	public static final String	Operation_ReJudge = "C9990";
	public static final String	Operation_FA = "C9999";
	public static final String	Operation_FAIN = "C9000";
	public static final String	Operation_TapeFix = "C9991";
	public static final String	Operation_Scrap = "C9995";
	public static final String	Operation_ScrapSampling = "C9993";
	public static final String	Operation_ScrapReserve = "C9994";
	public static final String	Operation_DeGradeSampling = "C9996";
	public static final String	Operation_DeGradeReserve = "C9997";
	public static final String	Operation_DeGrade = "C9998";
	public static final String	Operation_ReworkSampling = "R1000";
	public static final String	Operation_ReworkStartBank = "R1050";
	public static final String	Operation_ReworkBD = "R2050";
	public static final String	Operation_WithdrawSampling = "C9992";
	public static final String	Operation_PLDLoader = "P1001";
	public static final String	Operation_Aging = "T1002";
	public static final String	Operation_POL_ET_AOI = "P1003";
	public static final String	OPERATION_FINALTEST = "T1005";
	public static final String	OPERATION_EN_FINALTEST = "ET1400";
	public static final String	OPERATION_CAAging = "T2002";
	public static final String	OPERATION_DAS = "A1031";
	public static final String	OPERATION_POL = "P1002";
	public static final String  Operation_Bind_PCB_CD = "B1006";

	// Judge
	public static final String	Judge_OK = "OK";
	public static final String	Judge_Scrap = "Scrap";
	public static final String	Judge_FA = "FA";
	public static final String	Judge_Rework = "Rework";
	public static final String	Judge_ReJudge = "ReJudge";
	public static final String	Judge_DeGrade = "DeGrade";
	public static final String	Judge_WithDraw = "Withdraw";
	public static final String	Judge_TapeFix = "TapeFix";
	public static final String	Judge_NG = "NG";
	public static final String	Judge_Recovery = "Recovery";
	
	// Action Create Modify Delete
	public static final String	Action_Create = "Create";
	public static final String	Action_Update = "Update";
	public static final String	Action_Import = "Import";
	public static final String	Action_Modify = "Modify";
	public static final String	Action_Delete = "Delete";
	public static final String	Action_Complete = "Complete";
	public static final String	Action_DeAssign = "DeAssign";
	public static final String	Action_Assign = "Assign";
	public static final String	Action_Change = "Change";
	
	public static final String	OBAAction_AOI = "AOI";
	public static final String	OBAAction_IQC = "IQC";
	public static final String	OBAAction_Roller = "Roller";
	
	// ReasonCode Type
	public static final String	ReasonCode_DefectCode = "Defect Code";
	
	// Material Action
	public static final String	Action_Kitting = "Kitting";
	public static final String	Action_UnKitting = "UnKitting";
	
	
	// State
	public static final String	MDCSTATE_InStock = "InStock";
	public static final String	MDCSTATE_OutStock = "OutStock";
	public static final String	MDCSTATE_Received = "Received";
	public static final String	SHELFSTATE_On = "On";
	public static final String	SHELFSTATE_Off = "Off";
	public static final String	STATE_On = "On";
	public static final String	STATE_Off = "Off";
	public static final String	STATE_Auto = "Auto";
	public static final String	STATE_Manual = "Manual";
	
	public static final String	AlarmState_Set = "AlarmSet";
	public static final String	AlarmState_Clear = "AlarmClear";
	
	public static final String	ETC_Created = "Created";
	public static final String	ETC_Approval = "Approval";
	public static final String	ETC_Closed = "Closed";
	public static final String	ETC_Out = "OUT";
	public static final String	ETC_In = "IN";
	
	public static final String	Task_Status_Created = "Created";
	public static final String	Task_Status_Bound = "Bound";
	public static final String	Task_Status_Transfering = "Transfering";
	public static final String	Task_Status_Transfered = "Transfered";
	public static final String	Task_Status_Error = "Error";
	
	public static final String	Task_Type_RETURN = "RETURN";
	public static final String	Task_Type_CARGO = "CARGO";
	
	// Material State
	public static final String	Main_Material_Flag = "x";
	
	public static final String	MaterialState_Mount = "Mount";
	public static final String	MaterialState_DisMount = "DisMount";
	public static final String	MaterialState_InUse = "InUse";
	public static final String	MaterialState_Prepare = "Prepare";
	public static final String	MaterialState_Empty = "Empty";
	public static final String	MaterialState_PreMount = "PreMount";
	
	public static final String	ConsumableState_Available = "Available";
	public static final String	ConsumableState_Created = "Created";
	public static final String	ConsumableState_InUse = "InUse";
	public static final String	ConsumableState_Attach = "Attach";
	public static final String	ConsumableState_Scrap = "Scrap";
	public static final String	ConsumableState_CellOut = "CellOut";
	
	public static final String	MaterialRequestType_Call = "Call";
	public static final String	MaterialRequestType_Back = "Back";
	public static final String	MaterialRequestState_Requested = "Requested";
	public static final String	MaterialRequestState_Sending = "Sending";
	public static final String	MaterialRequestState_Received = "Received";
	public static final String	MaterialRequestState_Canceled = "Canceled";
	
	public static final String	MaterialLocation_Bank = "Bank";
	public static final String	MaterialLocation_MDCBank = "MDCBank";
	public static final String	MaterialLocation_OQABank = "OQABank";
	
	public static final String	MaterialAction_Split = "Split";
	public static final String	MaterialAction_Merge = "Merge";
	
	//资材履历的状态
	public static final String	MaterialState_Created = "Created";
	public static final String	MaterialState_Assign = "Assign";
	public static final String	MaterialState_Deassign = "Deassign";
	public static final String	MaterialState_Recycle = "Recycle";
	public static final String	MaterialState_Maintain = "Maintain";
	//资材回收后重投
	public static final String	MaterialState_Reinput = "Reinput";
	//抛料重投
	public static final String	MaterialState_ThrowInput = "ThrowInput";
	//未上板抛料
	public static final String	MaterialState_UnBondThrow = "UnbondThrow";
	//预压抛料
	public static final String	MaterialState_ProBondThrow = "ProbondThrow";
	public static final String	MaterialState_Rejudge = "Rejudge";
	public static final String	MaterialState_Scrapped = "Scrapped";
	public static final String MaterialState_MaintainCompleted = "MaintainCompleted";
	//资材等级
	public static final String	MaterialRejudge_Good = "G";
	public static final String	MaterialRejudge_NotGood = "N";
	//维修状态
	public static final String MaterialMaintain_DividePCB = "DividePCB";
	public static final String MaterialMaintain_RWClean = "RWClean";
	public static final String MaterialMaintain_AppearanceInspection = "AppearanceInspection";
	
	//WareHouse
	public static final String	WareHouse = "WareHouse";
	public static final String	Shelf = "Shelf";
	public static final String	Storage = "Storage";
	
	//Naming Rule
	public static final String	NamingRule_LOTID = "LOTID";
	public static final String	NamingRule_VirtualLotName = "VirtualLotName";
	public static final String	NamingRule_VirtualLotNameASSY = "VirtualLotNameASSY";
	public static final String	NamingRule_VirtualLotNameWithStation = "VirtualLotNameWithStation";
	public static final String	NamingRule_InnerBoxName = "InnerBoxName";
	public static final String	NamingRule_PalletName = "PalletName";
	public static final String	NamingRule_OQALotName = "OQALotName";
	public static final String	NamingRule_RequestOrder = "RequestOrder";
	public static final String	NamingRule_MaterialSplitName = "MaterialSplitName";
	public static final String	NamingRule_RMALotName = "RMALotName";
	public static final String	NamingRule_RMABoxName = "RMABoxName";
	public static final String	NamingRule_ArriveMaterialSNPrefix = "ArriveMaterialSNPrefix";
	public static final String	NamingRule_OCPanelName = "OCPanelName";
	public static final String	NamingRule_QPanelName = "QPanelName";
	public static final String	NamingRule_CellPanelPacking = "CellPanelPacking";
	
	//Grade
	public static final String	Grade_G = "G";
	public static final String	Grade_N = "N";
	
	//EN_Grade
	public static final String	Grade_1 = "1";
	public static final String	Grade_2 = "2";
	public static final String	Grade_3 = "3";
	public static final String	Grade_4 = "4";
	
	public static final String	Grade_S = "S";
	public static final String	Grade_A = "A";
	public static final String	Grade_F = "F";
	public static final String	Grade_0 = "0";
	public static final String	Grade_X = "X";
	public static final String	Grade_Q = "Q";
	public static final String	Grade_R = "R";
	
	//LotGrade
	public static final String	LotGrade_G = "G";
	
	//TimeControl
	public static final String TimeControl_NoMoreThan ="<=";
	public static final String TimeControl_NoLessThan =">=";
	
	//Lot Hold State
	public static final String	OnHold = "Y";
	public static final String	NotOnHold = "N";
	
	//Lot ProcessState
	public static final String	LotProcessState_RUN = "RUN";
	public static final String	LotProcessState_WAIT = "WAIT";
	
	//Lot ProcessState
	public static final String	Rework_NotInRework = "NotInRework";
	public static final String	Rework_InRework = "InRework";
	
	//Lot State
	public static final String	LotState_Released = "Released";
	public static final String	LotState_Completed = "Completed";
	public static final String	LotState_Created = "Created";
	public static final String	Lot_Shipped = "Shipped";
	public static final String	Lot_Scrapped = "Scrapped";
	public static final String  Lot_Withdrew = "Withdrew";
	public static final String  Lot_TapeFix = "TapeFix";
	public static final String	Lot_Emptied = "Emptied";
	public static final String	Lot_InRework = "InRework";
	public static final String	Lot_NotInRework = "NotInRework";
	
	// WO State
	public static final String	State_Released = "Released";
	public static final String	State_Active = "Active";
	public static final String	State_Reserve = "Reserve";
	public static final String	State_Binding = "Binding";
	public static final String	State_UnBinding = "UnBinding";
	
	// Panel Operation
	public static final String	Operation_Bind_FPC = "B1003";
	public static final String	Operation_Bind_PCB = "B1005";
	public static final String	Operation_Bind_S_FPC = "A1016";
	//public static final String	RWOperation_Bind_PCB = "EB1400";
	//public static final String	RWOperation_Bind_FPC = "EB1300";
	
	
	// Material Type
	public static final String	MaterialType_FPC = "FPC";
	public static final String	MaterialType_BLU = "BLU";
	public static final String	MaterialType_PCB = "PCB";
	public static final String	MaterialType_IC = "IC";
	public static final String	MaterialType_S_FPC = "S-FPC";
	//public static final String	MaterialType_EMD_MOT = "EMD MOT";
	public static final String	MaterialType_MOT = "MOT";
	public static final String	MaterialType_MDL_2nd = "MDL_2nd";
	public static final String	MaterialType_Cover = "Cover";
	public static final String	MaterialType_MDL = "MDL";
	
	//Product Type
	public static final String	Panel = "Panel";
	public static final String	QPanel = "QPanel";
	public static final String	RMAPanel = "RMAPanel";
	public static final String	Glass = "Glass";
	public static final String	Lot = "Lot";
	
	// Group Type
	public static final String	Box = "Box";
	public static final String	ProcessGroup = "ProcessGroup";
	public static final String	RMABox = "RMABox";
	public static final String	InnerBox = "InnerBox";
	public static final String	OuterBox = "OuterBox";
	public static final String	Pallet = "Pallet";
	public static final String	VirtualLot = "VirtualLot";
	public static final String	OQALot = "OQALot";
	public static final String	Aging = "AGING";
	
	// Event
	public static final String	EventName_CreateLot = "CreateLot";
	public static final String	EventName_CreateVirtualLot = "CreateVirtualLot";
	public static final String	EventName_OQAPanelNGToReJudge = "OQAPanelNGToReJudge";
	public static final String	EventName_DeassignProcessGroup = "DeassignProcessGroup";
	public static final String	EventName_DeassignSuperProcessGroup = "DeassignSuperProcessGroup";
	public static final String	EventName_OQAInspection = "OQAInspection";
	public static final String	EventName_OQAInspectionAutoHold = "OQAInspectionAutoHold";
	public static final String	EventName_OQACalculate = "OQACalculate";
	public static final String	EventName_DeassignOQALot = "DeassignOQALot";
	public static final String	EventName_OQAPanelNGReturnLot = "OQAPanelNGReturnLot";
	public static final String	EventName_OpCallSend = "OpCallSend";
	public static final String	EventName_TrackIn = "TrackIn";
	public static final String	EventName_TrackOut = "TrackOut";
	public static final String	EventName_ReworkTrackIn = "ReworkTrackIn";
	public static final String	EventName_ReworkTrackOut = "ReworkTrackOut";
	public static final String	EventName_ReserveAutoHold = "ReserveAutoHold";
	public static final String	EVENTNAME_FINISHEPROCESSOPERATION = "ReserveAutoHold";
	public static final String	EventName_ProcessAutoSkip = "ProcessAutoSkip";
	public static final String	EventName_MaterialMerge = "MaterialMerge";
	public static final String	EventName_MaterialSplit = "MaterialSplit";
	public static final String	EventName_MaterialKitting = "MaterialKitting";
	public static final String	EventName_MaterialUnKitting = "MaterialUnKitting";
	public static final String	EventName_LoadRequest = "LoadRequest";
	public static final String	EventName_UnloadRequest = "UnloadRequest";
	public static final String	EventName_RMAPanelUpdate = "RMAPanelUpdate";
	public static final String	EventName_RMAPanelDelete = "RMAPanelDelete";
	public static final String	EventName_LabelCreate = "LabelCreate";
	public static final String	EventName_LabelModify = "LabelModify";
	public static final String	EventName_ManualBindingMaterial = "ManualBindingMaterial";
	public static final String	EventName_ManualDeAssignMaterial = "ManualDeAssignMaterial";
	public static final String	EventName_AddPackingTimes = "AddPackingTimes";
	public static final String	EventName_PanelFirstAgingNG = "PanelFirstAgingNG";
	public static final String	EventName_DeassignBoxChangeOperation = "DeassignBoxChangeOperation";
	public static final String	EventName_OBAMaterialAOI = "OBAMaterialAOI";
	public static final String	EventName_OBAMaterialIQC = "OBAMaterialIQC";
	public static final String	EventName_OBAMaterialRoller = "OBAMaterialRoller";
	public static final String	EventName_WorkOrderBindingLine = "WorkOrderBindingLine";
	public static final String	EventName_WorkOrderBindingLineCancel = "WorkOrderBindingLineCancel";
	public static final String	EventName_WorkOrderBindingLineActive = "WorkOrderBindingLineActive";
	public static final String	EventName_ActiveAutoCancel = "ActiveAutoCancel";
	public static final String	EventName_CreateAGVTask = "CreateAGVTask";
	public static final String	EventName_OCBindMaterial = "OCBindMaterial";
	public static final String	EventName_ClearBoxLocatoin = "ClearBoxLocatoin";
	
	// MessageName
	public static final String	MessageName_PanelProcessEndReply = "PanelProcessEndReply";
	public static final String	MessageName_PanelBindMaterialReply = "PanelBindMaterialReply";
	public static final String	MessageName_MakeLotReply = "MakeLotReply";
	public static final String	MessageName_LotInfoDownLoadReply = "LotInfoDownLoadReply";
	public static final String	MessageName_MachineStateChanged = "MachineStateChanged";
	public static final String	MessageName_CommunicationStateChanged = "CommunicationStateChanged";
	public static final String	MessageName_CuttingBindingPanelName = "CuttingBindingPanelName";
	public static final String	MessageName_CuttingBindingPanelNameReply = "CuttingBindingPanelNameReply";
	public static final String	MessageName_QPanelInfoReply = "QPanelInfoReply";
	public static final String	MessageName_materialInfoReply = "MaterialInfoReply";
	
	//Factory
	public static final String Factory_BADT = "BADT";
	public static final String Factory_CELL = "CELL";
	public static final String Factory_Default = "BADT";
	public static final String SAP_FACTORY_ONE = "V151";
	public static final String SAP_FACTORY_TWO = "V161";
	
	// FGCodeAttribute
	public static final String FGCodeAttribute_AOIFlipAngle = "AOIFlipAngle";
	public static final String FGCodeAttribute_AllowPAOSkipOperation = "AllowPAOSkipOperation";
	public static final String FGCodeAttribute_VirtualLotQty = "VirtualLotQty";
	public static final String FGCodeAttribute_PackingLot = "PackingLot";
	public static final String FGCodeAttribute_BindFPCQty = "BindFPCQty";
	public static final String FGCodeAttribute_InnerBoxNameRule = "InnerBoxNameRule";
	public static final String FGCodeAttribute_OuterBoxNameRule = "OuterBoxNameRule";
	public static final String FGCodeAttribute_PalletNameRule = "PalletNameRule";
	public static final String FGCodeAttribute_HighestReleasedGrade = "HighestReleasedGrade";
	public static final String FGCodeAttribute_EN_HighestRevisionGrade = "EN-HighestRevisionGrade";
	public static final String FGCodeAttribute_ModuleNameKeyCode = "ModuleNameKeyCode";
	public static final String FGCodeAttribute_ModuleNameLength = "ModuleNameLength";
	public static final String FGCodeAttribute_OLBCheckEndMaterialType = "OLBCheckEndMaterialType";
	public static final String FGCodeAttribute_ASSYCheckEndMaterialType = "ASSYCheckEndMaterialType";
	public static final String FGCodeAttribute_PanelNameLength = "PanelNameLength";
	public static final String FGCodeAttribute_FGCodeStartBit = "FGCodeStartBit";
	public static final String FGCodeAttribute_FGCodeFeatureCodes = "FGCodeFeatureCodes";
	public static final String FGCodeAttribute_PanelMaterialSpec = "PanelMaterialSpec";
	public static final String FGCodeAttribute_CellFGCodeVersion = "CellFGCodeVersion";
	public static final String FGCodeAttribute_StockLocation = "StockLocation";
	public static final String FGCodeAttribute_CELL_Format_ = "CELL_Format_";
	public static final String FGCodeAttribute_PCB_Format_ = "PCB_Format_";
	public static final String FGCodeAttribute_BLU_Format_ = "BLU_Format_";
	public static final String FGCodeAttribute_FPC_Format_ = "FPC_Format_";
	public static final String FGCodeAttribute_MDL_2nd_Format_ = "MDL_2nd_Format_";
	public static final String FGCodeAttribute_CG_Format_ = "CG_Format_";
	
	public static final String FGCodeAttribute_BLUKeyCode = "BLUKeyCode";
	public static final String FGCodeAttribute_BLULength = "BLULength";
	public static final String FGCodeAttribute_FPCKeyCode = "FPCKeyCode";
	public static final String FGCodeAttribute_FPCLength = "FPCLength";
	public static final String FGCodeAttribute_PCBKeyCode = "PCBKeyCode";
	public static final String FGCodeAttribute_PCBLength = "PCBLength";
	
	//Location
	public static final String PROCESSGROUP_STOCK_LOCATION = "testLocation1";
	public static final String CONSUMABLE_STOCK_LOCATION = "testLocation2";

	// Menu
	public static final String Menu_CommonTrackOut = "CommonTrackOut";
	
	//DetailProcessOperationType
	public static final String OperationType_OQA = "OQA";
	public static final String OperationType_DeGrade = "DeGrade";
	public static final String OperationType_Ship = "Ship";
	public static final String OperationType_Packing = "Packing";
	public static final String OperationType_ReJudge = "ReJudge";
	public static final String OperationType_Scrap = "Scrap";
	public static final String OperationType_Bank = "Bank";
	public static final String OperationType_FA = "FA";
	public static final String OperationType_Rework = "Rework";
	public static final String OperationType_Waiting = "Waiting";
	public static final String OperationType_ReworkBindingOperation = "ReworkBindingOperation";
	
	
	// OQA
	public static final String OQA_nppmIndexCoefficient = "1000000";
	public static final Double OQA_nppmTarget = 1000000.00;

	// Enum
	public static final String Enum_OQAActionTime = "OQAActionTime";
	public static final String Enum_PackingCheckWO = "PackingCheckWO";
	public static final String Enum_LabelRequestURL = "LabelRequestURL";
	public static final String Enum_LabelPathPrefix = "LabelPathPrefix";
	public static final String Enum_ShipSAPLocation = "ShipSAPLocation";
	public static final String Enum_LineOutOperationAction = "LineOutOperationAction";
	public static final String Enum_CheckModuleNameBinging = "CheckModuleNameBinging";
	public static final String Enum_CheckRevisionCode = "CheckRevisionCode";
	public static final String Enum_RecycleMaterialType = "RecycleMaterialType";
	public static final String Enum_MachineNeedMaterialValidation = "MachineNeedMaterialValidation";
	public static final String Enum_MaterialTypeIsSNType = "MaterialTypeIsSNType";
	
	// Machine Group
	public static final String MachineGroup_POL = "POL";
	public static final String MachineGroup_Skip = "Skip";
	public static final String MachineGroup_Aging = "Aging";
	public static final String MachineGroup_Cutting = "Cutting";
	
	// Number
	public static final String Zero = "0";
	
	// 工单类型
	public static final String WOType_Production = "ZP10";
	public static final String WOType_RT = "ZP60";
	public static final String WOType_RMA = "ZP70";
	public static final String WOType_EN = "ZP80";
	public static final String WOType_Rework = "ZP90";
	
	//sap 收货类型
	//收货
	public static final String SAP_RECEIVING = "A";
	//移库
	public static final String SAP_WAREHOUSE = "B";
	//降级
	public static final String SAP_DEMOTE = "C";
	//研发
	public static final String SAP_RESEARCH = "D";
	
	// CommunicationState
	public static final String CommunicationState_Remote = "REMOTE";
	public static final String CommunicationState_Local = "LOCAL";
	public static final String CommunicationState_Offline = "OFFLINE";
	
	// Machine State
	public static final String MachineState_UNKNOWN = "UNKNOWN";
	
	// Panel Area 
	public static final String Panel_Area_OLB = "OLB";
	
	// Reserve Action Type
	public static final String ReserveActionType_Hold = "Hold";
	// SAP Message Name
	public static final String sap_message_user_send = "MES-SAP";
	public static final String sap_message_user_receive = "SAP-MES";
	// 产品 ship 收货
	public static final String sap_message_ProductReceive = "SAP_ProductReceive";
	// 产品 ship 收货回复
	public static final String sap_message_ProductReceiveResponse = "SAP_ProductReceiveResponse";
	// 产品 ship 收货 , SAP 执行结果下发
	public static final String sap_message_PalletResultReceive = "SAP_PalletResultReceive";
	// SAP BOM 结果下发
	public static final String sap_message_SAPBOMDown = "SAP_SAPBOMDown";
	
	// Hold Type
	public static final String Hold_Type_OQAHold = "OQAHold";
	public static final String Hold_Password_OQAHold = "OQAHold-Password";
	
	public interface ObjectAttribute
	{
		public static final String  IQC_BANK                                = "IQC_BANK";
        public static final String  COPY                                    = "COPY";
        public static final String  COPYV2                                  = "COPYV2";
		public static final String	Lot										= "Lot";
		public static final String	LotHistory								= "LotHistory";
		public static final String	Product									= "Product";
		public static final String	ProductHistory							= "ProductHistory";
		public static final String	MACHINENAME								= "MACHINENAME";
		public static final String	MATERIALPOSITION								= "MATERIALPOSITION";
		public static final String	MATERIALSTATE								= "MATERIALSTATE";
		public static final String	MATERIALJUDGE								= "MATERIALJUDGE";
		public static final String	MATERIALDECS								= "MATERIALDECS";
		public static final String	REMARK1								= "REMARK1";
		public static final String	CREATETIMES								= "CREATETIMES";
		public static final String	REINPUTTIMES								= "REINPUTTIMES";
		public static final String	THROWINPUTTIMES								= "THROWINPUTTIMES";
		public static final String	ULMPROCESSFLAG							= "ULMPROCESSFLAG";
		public static final String	COVERTRAY								= "COVERTRAY";
		public static final String	SUPERRECIPENAME							= "SUPERRECIPENAME";
		public static final String	UNITLIST								= "UNITLIST";
		public static final String	UNITNAME								= "UNITNAME";
		public static final String	PORTNAME								= "PORTNAME";
		public static final String	SUBUNITNAME								= "SUBUNITNAME";
		public static final String	MessageLogSize							= "MessageLogSize";
		public static final String	ENUMNAME								= "ENUMNAME";
		public static final String	ENUMVALUE								= "ENUMVALUE";
		public static final String	DEFAULTFLAG								= "DEFAULTFLAG";
		public static final String	ALARMCODE								= "ALARMCODE";
		public static final String	ALARMSORT								= "ALARMSORT";
		public static final String	ALARMID									= "ALARMID";
		public static final String	ALARMSEVERITY							= "ALARMSEVERITY";
		public static final String	ALARMSTATE								= "ALARMSTATE";
		public static final String	ALARMTEXT								= "ALARMTEXT";
		public static final String	LASTEVENTNAME							= "LASTEVENTNAME";
		public static final String	LASTEVENTTIMEKEY						= "LASTEVENTTIMEKEY";
		public static final String	EVENTNAME								= "EVENTNAME";
		public static final String	EVENTTIMEKEY							= "EVENTTIMEKEY";
		public static final String	EVENTTIME								= "EVENTTIME";
		public static final String	EVENTUSER								= "EVENTUSER";
		public static final String	EVENTFLAG								= "EVENTFLAG";
		public static final String	ISSUETIMEKEY							= "ISSUETIMEKEY";
		public static final String	DETAILMACHINETYPE						= "DETAILMACHINETYPE";
		public static final String	MACHINEHOLDSTATE						= "MACHINEHOLDSTATE";
		public static final String	TRAYGROUPNAME							= "TRAYGROUPNAME";
		public static final String	PROCESSGROUP							= "PROCESSGROUP";
		public static final String	PROCESSGROUPNAME						= "PROCESSGROUPNAME";
		public static final String	UPNCODE						            = "UPNCODE";
		public static final String	PROCESSGROUPTYPE						= "PROCESSGROUPTYPE";
		public static final String	SUPERMACHINENAME						= "SUPERMACHINENAME";
		public static final String	FACTORYNAME								= "FACTORYNAME";
		public static final String	RECEIVEFLAG								= "RECEIVEFLAG";
		public static final String	PRODUCTSPECNAME							= "PRODUCTSPECNAME";
		public static final String	PRODUCTIONTYPE							= "PRODUCTIONTYPE";
		public static final String	PROCESSFLOWNAME							= "PROCESSFLOWNAME";
		public static final String	QFGCODE							= "QFGCODE";
		public static final String	PROCESSOPERATIONNAME					= "PROCESSOPERATIONNAME";
		public static final String	AGVOPERATION					= "AGVOPERATION";
		public static final String	TRAYGYNAME								= "TRAYGYNAME";
		public static final String	BOXLIST									= "BOXLIST";
		public static final String	DETAILUNITTYPE							= "DETAILUNITTYPE";
		public static final String	HOLD									= "HOLD";
		public static final String	FDCHOLD									= "FDCHOLD";
		public static final String	CLEARALARMTIME							= "CLEARALARMTIME";
		public static final String	HOLDPASSWORD							= "HOLDPASSWORD";
		public static final String	PROBEID									= "PROBEID";
		public static final String	CALIBRATIONCHANNELCODE					= "CALIBRATIONCHANNELCODE";
		
		public static final String  ATTACHQUANTITY                          = "ATTACHQUANTITY";
		public static final String  ATTACHTIME                              = "ATTACHTIME";
		public static final String  CUSTOMERCODE                            = "CUSTOMERCODE";
		public static final String  ABNORMALID                            	= "ABNORMALID";
		public static final String  LOTREMARK3                            	= "LOTREMARK3";
		public static final String	SEQUENCEID								= "SEQUENCEID";
		public static final String	TOSEQUENCEID							= "TOSEQUENCEID";
		public static final String	CONSUMEDCONSUMABLENAME					= "CONSUMEDCONSUMABLENAME";
		public static final String	CONSUMERTIMEKEY							= "CONSUMERTIMEKEY";
		public static final String	EVENTCOMMENT							= "EVENTCOMMENT";
		public static final String	CONSUMEDDURABLENAME						= "CONSUMEDDURABLENAME";
		public static final String	CONSUMEDLOTNAME							= "CONSUMEDLOTNAME";
		public static final String	CONSUMERLOTNAME							= "CONSUMERLOTNAME";
		public static final String	CONSUMABLENAME							= "CONSUMABLENAME";
		public static final String	MODULENAME							    = "MODULENAME";
		public static final String	CONSUMABLETYPE							= "CONSUMABLETYPE";
		public static final String	CONSUMABLESPECNAME						= "CONSUMABLESPECNAME";
		public static final String	REQUESTQTY								= "REQUESTQTY";
		public static final String	CHECKSTATE						        = "CHECKSTATE";
		public static final String	CREATEUSER						        = "CREATEUSER";
		public static final String	CONSUMEUNIT					        	= "CONSUMEUNIT";
		public static final String	COVERNAME								= "COVERNAME";
		public static final String	LOTNAME									= "LOTNAME";
		public static final String	READPANELNAME						    = "READPANELNAME";
		public static final String	SOURCELOTNAME							= "SOURCELOTNAME";
		public static final String	PRODUCTNAME								= "PRODUCTNAME";
		public static final String	PANELNAME								= "PANELNAME";
		public static final String	CARRIERNAME								= "CARRIERNAME";
		public static final String	CARRIER								    = "CARRIER";
		public static final String	CHECKINCODE								= "CHECKINCODE";
		public static final String	TRAYNAME								= "TRAYNAME";
		public static final String	TRAYSPECNAME							= "TRAYSPECNAME";
		public static final String	DEPARTMENT						    	= "DEPARTMENT";
		public static final String	TECHNICALOFFICE						    = "TECHNICALOFFICE";
		public static final String	LINESECTION						        = "LINESECTION";
		public static final String	TITLE						            = "TITLE";
		public static final String	WORKERID						        = "WORKERID";
		public static final String	CLEANCOUNT						        = "CLEANCOUNT";
		public static final String	MAXCLEANCOUNT						    = "MAXCLEANCOUNT";
		public static final String	WORKERNAME						        = "WORKERNAME";
		public static final String	RECORDTIME						        = "RECORDTIME";		
		public static final String	DURABLENAME								= "DURABLENAME";
		public static final String	DURABLECLEANSTATE						= "DURABLECLEANSTATE";
		public static final String	DURABLETYPE								= "DURABLETYPE";
		public static final String	DURABLESPECNAME							= "DURABLESPECNAME";
		public static final String	LOTGRADE								= "LOTGRADE";
		public static final String	PANELGRADE								= "PANELGRADE";
		public static final String	PANELJUDGE								= "PANELJUDGE";
		public static final String	SINGLEPANELGRADE						= "SINGLEPANELGRADE";
		public static final String	LOTDETAILGRADE							= "LOTDETAILGRADE";
		public static final String	WEIGHT									= "WEIGHT";
		public static final String	NTCONSTANTMAP							= "ntConstantMap";
		public static final String	CHK										= "CHK";
		public static final String	ISSUE									= "ISSUE";
		public static final String	CLEAR									= "CLEAR";
		public static final String	DESCRIPTION								= "DESCRIPTION";
		public static final String	SUPERREASONCODE							= "SUPERREASONCODE";
		public static final String	LEVELNO								    = "LEVELNO";
		public static final String	AVAILABILITY							= "AVAILABILITY";
		public static final String	CODECATEGORY							= "CODECATEGORY";
		public static final String	DETAILREASONCODE						= "DETAILREASONCODE";
		public static final String	ENGDESC								    = "ENGDESC";
		public static final String	SUPERREASONCODEGROUP					= "SUPERREASONCODEGROUP";
		public static final String	NOTE								    = "NOTE";
		public static final String	DETAILUSEOPERATION						= "DETAILUSEOPERATION";
		public static final String	DESCRIPTION_PLT							= "DESCRIPTION_PLT";
		public static final String	ServerName								= "ServerName";
		public static final String	location								= "location";
		public static final String	factory									= "factory";
		public static final String	cim										= "cim";
		public static final String	mode									= "mode";
		public static final String	type									= "type";
		public static final String	LOCAL									= "_LOCAL.";
		public static final String	_LOCAL									= "_LOCAL";
		public static final String	Marked_Sucject							= "Maked SubjectName=";
		public static final String	SenderName								= "senderName = ";
		public static final String	Server_Name								= "serverName = ";
		public static final String	SendSubject								= "SEND : Subject=";
		public static final String	SendMessage								= "SEND : Message=";
		public static final String	ScrapMode								= "Scrap Mode";
		public static final String	Query_Condition							= "=?";
		public static final String	TIMEKEY									= "TIMEKEY";
		public static final String	OLDAREANAME								= "OLDAREANAME";
		public static final String	OLDDESTINATIONFACTORYNAME				= "OLDDESTINATIONFACTORYNAME";
		public static final String	OLDFACTORYNAME							= "OLDFACTORYNAME";
		public static final String	OLDLOTGRADE								= "OLDLOTGRADE";
		public static final String	OLDOPERATIONINTIME						= "OLDOPERATIONINTIME";
		public static final String	OLDPROCESSFLOWNAME						= "OLDPROCESSFLOWNAME";
		public static final String	OLDPROCESSOPERATIONNAME					= "OLDPROCESSOPERATIONNAME";
		public static final String	OLDPRODUCTIONTYPE						= "OLDPRODUCTIONTYPE";
		public static final String	OLDPRODUCTQUANTITY						= "OLDPRODUCTQUANTITY";
		public static final String	OLDPRODUCTREQUESTNAME					= "OLDPRODUCTREQUESTNAME";
		public static final String	OLDPRODUCTSPECNAME						= "OLDPRODUCTSPECNAME";
		public static final String	OLDPRODUCTTYPE							= "OLDPRODUCTTYPE";
		public static final String	OLDSUBPRODUCTQUANTITY					= "OLDSUBPRODUCTQUANTITY";
		public static final String	OLDSUBPRODUCTTYPE						= "OLDSUBPRODUCTTYPE";
		public static final String	KEY										= "KEY";
		public static final String	SUBVALUE								= "SUBVALUE";
		public static final String	BOXIDVALUE								= "BOXIDVALUE";
		public static final String	QTYVALUE								= "QTYVALUE";
		public static final String	SPECVALUE								= "SPECVALUE";
		public static final String	DATEVALUE								= "DATEVALUE";
		public static final String	CREATETIME								= "CREATETIME";
		public static final String	BAGIDVALUE								= "BAGIDVALUE";
		public static final String	QTYV									= "QTYV";
		public static final String	TLTIDVALUE								= "TLTIDVALUE";
		public static final String	QTY										= "QTY";
		public static final String	PLTIDVALUE								= "PLTIDVALUE";
		public static final String	BQTYVALUE								= "BQTYVALUE";
		public static final String	MQTY									= "MQTY";
		public static final String	GWV										= "GWV";
		public static final String	NWVALUE									= "NWVALUE";
		public static final String	GLASSQTY								= "GLASSQTY";
		public static final String	REELVALUE								= "REELVALUE";
		public static final String	LNVALUE									= "LNVALUE";
		public static final String	CHKV									= "CHKV";
		public static final String	LABELZPLSTRING							= "LABELZPLSTRING";
		public static final String	EQP_ID									= "EQP ID: ";
		public static final String	MESSAGENAME_URL							= "Message/Header/MESSAGENAME";
		public static final String	MESSAGEBODY_URL							= "//Message/Body";
		public static final String	MESSAGEHEADER_URL						= "//Message/Header";
		public static final String	ProductProcessDataReply					= "ProductProcessDataReply";
		public static final String	ProductInspectionResultReply			= "ProductInspectionResultReply";
		public static final String	MaterialValidationReply					= "MaterialValidationReply";
		public static final String	ReplySubject							= "replySubject = ";
		public static final String	WIPDATE									= "WIPDATE";
		public static final String	WIPDATA									= "WIPDATA";
		public static final String	MESSAGENAME								= "MESSAGENAME";
		public static final String	MAXCOUNT								= "MAXCOUNT";
		public static final String	MESSAGECOUNT							= "MESSAGECOUNT";
		public static final String	RESULTDESCRIPTION						= "RESULTDESCRIPTION";
		public static final String	Return									= "Return";
		public static final String	RETURN									= "RETURN";
		public static final String	RETURNMESSAGE							= "RETURNMESSAGE";
		public static final String	STATE									= "STATE";
		public static final String	SUBSTATE								= "SUBSTATE";
		public static final String	Listening								= "Listening";
		public static final String	UnixProcessReport						= "UnixProcessReport";
		public static final String	SUBMESSAGENAME							= "SUBMESSAGENAME";
		public static final String	InsertErrorMessageLog					= "InsertErrorMessageLog";
		public static final String	ErrorMessageLog							= "ErrorMessageLog";
		public static final String	MessageLog								= "MessageLog";
		public static final String	WriteFlag								= "WriteFlag";
		public static final String	TRANSACTIONID							= "TRANSACTIONID";
		public static final String	IP										= "IP";
		public static final String	ERRORMESSAGE							= "ERRORMESSAGE";
		public static final String	MESSAGE									= "MESSAGE";
		public static final String	ORIGINALSOURCESUBJECTNAME				= "ORIGINALSOURCESUBJECTNAME";
		public static final String	SOURCESUBJECTNAME						= "SOURCESUBJECTNAME";
		public static final String	TARGETSUBJECTNAME						= "TARGETSUBJECTNAME";
		public static final String	Seq										= "Seq";
		public static final String	SEQ										= "SEQ";
		public static final String	ID										= "ID";
		public static final String	NG										= "NG";
		public static final String	SERVERNAME_L							= "SERVERNAME";
		public static final String	MACHINERECIPENAME						= "MACHINERECIPENAME";
		public static final String	DETAILPROCESSOPERATIONTYPE				= "DETAILPROCESSOPERATIONTYPE";
		public static final String	PROCESSFLOWTYPE							= "PROCESSFLOWTYPE";
		public static final String	PRODUCTCOUNTONXAXIS						= "PRODUCTCOUNTONXAXIS";
		public static final String	PRODUCTCOUNTONYAXIS						= "PRODUCTCOUNTONYAXIS";
		public static final String	PANELLOTSERIAL							= "AA";
		public static final String	GLASSMAP								= "GlassMap";
		public static final String	GlassMap_TopRight						= "GlassMap_TopRight";
		public static final String	GlassMap_BottomLeft						= "GlassMap_BottomLeft";
		public static final String	GlassMap_BottomRight					= "GlassMap_BottomRight";
		public static final String	SERIAL									= "SERIAL";
		public static final String	GLASSMAPNAME							= "GLASSMAPNAME";
		public static final String	POSITION								= "POSITION";
		public static final String	YPOSITION								= "YPOSITION";
		public static final String	XPOSITION								= "XPOSITION";
		public static final String	LOTLIST									= "LOTLIST";
		public static final String	DURABLESPEC								= "DURABLESPEC";
		public static final String	CLEANSTATE								= "CLEANSTATE";
		public static final String	RECIPEVALIDATIONFLAG					= "RECIPEVALIDATIONFLAG";
		public static final String	LOADCOMPLETESTATUS						= "LOADCOMPLETESTATUS";
		public static final String	JOBSTATUS								= "JOBSTATUS";
		public static final String	DESTINATIONMACHINENAME					= "DESTINATIONMACHINENAME";
		public static final String	DESTINATIONPOSITIONNAME					= "DESTINATIONPOSITIONNAME";
		public static final String	DURABLESTATE							= "DURABLESTATE";
		public static final String	AUTO									= "AUTO";
		public static final String	ReworkCount								= "ReworkCount";
		public static final String	SUBPRODUCTUNITQUANTITY					= "SUBPRODUCTUNITQUANTITY";
		public static final String	CREATEPRODUCTQUANTITY					= "CREATEPRODUCTQUANTITY";
		public static final String	CREATESUBPRODUCTQUANTITY				= "CREATESUBPRODUCTQUANTITY";
		public static final String	SUBPRODUCTQUANTITY						= "SUBPRODUCTQUANTITY";
		public static final String	LotInfoSendFlag							= "LotInfoSendFlag: ";
		public static final String	RULENAME								= "RULENAME";
		public static final String	SQL_TEXT								= "SQL_TEXT";
		public static final String	PREFIX									= "PREFIX";
		public static final String	LASTSERIALNO							= "LASTSERIALNO";
		public static final String	TOYEAR									= "TOYEAR";
		public static final String	TOMONTH									= "TOMONTH";
		public static final String	TODAY									= "TODAY";
		public static final String	REWORKSTATE								= "REWORKSTATE";
		public static final String	PRODUCTSTATE							= "PRODUCTSTATE";
		public static final String	PRODUCTLIST								= "PRODUCTLIST";
		public static final String	LOTSTATE								= "LOTSTATE";
		public static final String	LOTPROCESSSTATE							= "LOTPROCESSSTATE";
		public static final String	LOTHOLDSTATE							= "LOTHOLDSTATE";
		public static final String	ETCOUTFLAG								= "ETCOUTFLAG";
		public static final String	ITEMVALUE								= "ITEMVALUE";
		public static final String	PRODUCTGRADE							= "PRODUCTGRADE";
		public static final String	SUBPRODUCTGRADES						= "SUBPRODUCTGRADES";
		public static final String	MODULESTARTFLAG							= "MODULESTARTFLAG";
		public static final String	LASTEVENTUSER							= "LASTEVENTUSER";
		public static final String	LASTEVENTCOMMENT						= "LASTEVENTCOMMENT";
		public static final String	BSLABELPRINTService						= "BSLABELPRINTService";
		public static final String  BSALARMCONFIGHISTORYService    			= "BSALARMCONFIGHISTORYService";
        public static final String  BSALARMCONFIGRECEIVERService    		= "BSALARMCONFIGRECEIVERService";
        public static final String  BSALARMCONFIGService    				= "BSALARMCONFIGService";
		public static final String	BSYMSPANELAOIJUDGEService				= "BSYMSPANELAOIJUDGEService";
		public static final String	BSLOTCONSUMABLEASSYService				= "BSLOTCONSUMABLEASSYService";
		public static final String	BSLOTCONSUMABLEASSYHistoryService		= "BSLOTCONSUMABLEASSYHistoryService";
		public static final String	BSDEFECTCODEHISTORYService				= "BSDEFECTCODEHISTORYService";
		public static final String	BSRECIPEPARAMETERService				= "BSRECIPEPARAMETERService";
		public static final String	BSRECIPEService							= "BSRECIPEService";
		public static final String	BSRECIPEPARAMETERHistoryService			= "BSRECIPEPARAMETERHistoryService";
		public static final String	BSRECIPEHistoryService					= "BSRECIPEHistoryService";
		public static final String	BSPERSONNELINFOService					= "BSPERSONNELINFOService";
		public static final String	BSSTANDARDCAPACITYService				= "BSSTANDARDCAPACITYService";
		public static final String	BSNOTICEService							= "BSNOTICEService";
		public static final String  BSOQARULEService                        = "BSOQARULEService";
        public static final String  BSOQARULEHISTORYService                 = "BSOQARULEHISTORYService";
        public static final String  BSOQAKPIService                 		= "BSOQAKPIService";
        public static final String  BSCUSTOMQUERYService                    = "BSCUSTOMQUERYService";
        public static final String  BSOQAMEMBERService                      = "BSOQAMEMBERService";
        public static final String  BSOQAGROUPService                       = "BSOQAGROUPService";
        public static final String  INF_PLMBOMService                       = "INF_PLMBOMService";
        public static final String  BSDCDATASPECService                     = "BSDCDATASPECService";
        public static final String  BSDAILYPLANService                      = "BSDAILYPLANService";
        public static final String  BSPLMBOMService                         = "BSPLMBOMService";
        public static final String  BSPLMBOMHISTORYService                  = "BSPLMBOMHISTORYService"; 
        public static final String  BSBATCHGROUPService                     = "BSBATCHGROUPService";
        public static final String  BSBATCHGROUPHISTORYService              = "BSBATCHGROUPHISTORYService";
        public static final String  BSUNLOADTRAYINFOService            	    = "BSUNLOADTRAYINFOService";
        
		public static final String	STATEVALUE								= "STATEVALUE";
		public static final String	CONSUMABLEACTION						= "CONSUMABLEACTION";
		public static final String	CARRIERLIST								= "CARRIERLIST";
		public static final String	InsertMessageLog						= "InsertMessageLog";
		public static final String	BOXIDS									= "BOXIDS";
		public static final String	LOTNAMELIST								= "LOTNAMELIST";
		public static final String	BOXNAMELIST								= "BOXNAMELIST";
		public static final String	nulls									= "null";
		public static final String	EACBoxID								= "EACBoxID";
		public static final String	Decimal_Format_EACBOX					= "######0.00";
		public static final String	Decimal_Format_EACBOX_PRODUCTSIZE		= "#,##00.0";
		public static final String	Decimal_Format_MODBOX					= "######0.00";
		public static final String	Decimal_Format_MODBOX_PRODUCTSIZE		= "#,##00.0";
		public static final String	Decimal_Format_MODTRAYGROUP				= "######0.00";
		public static final String	Decimal_Format_MODTRAYGROUP_PRODUCTSIZE	= "#,##00.0";
		public static final String	Split_Format_EACBOX_PRODUCTSIZE			= "\\.";
		public static final String	Split_Format_MODBOX_PRODUCTSIZE			= "\\.";
		public static final String	Split_Format_MODTRAYGROUP_PRODUCTSIZE	= "\\.";
		public static final String	Decimal_Format_PRODUCTSIZE				= "#,##000";
		public static final String	YEAR									= "YEAR";
		public static final String	MONTH									= "MONTH";
		public static final String	WEEK									= "WEEK";
		public static final String	DAY										= "DAY";
		public static final String	Year									= "Year";
		public static final String	Month									= "Month";
		public static final String	Line									= "Line";
		public static final String	Day										= "Day";
		public static final String	SHIFT									= "SHIFT";
		public static final String	InnerBoxList							= "InnerBoxList";
		public static final String	Exact									= "Exact";
		public static final String	Range									= "Range";
		public static final String	None									= "None";
		public static final String	RECIPEVALIDATION						= "RECIPEVALIDATION";
		public static final String	UndefinedCode							= "UndefinedCode";
		public static final String	RETURNMSG								= "RETURNMSG";
		public static final String	Sign_DoubleSlash_r						= "\\r";
		public static final String	Sign_Slash_r							= "\r";
		public static final String	Sign_DoubleSlash_n						= "\\n";
		public static final String	Sign_Slash_n							= "\n";
		public static final String	Param_Null_Message						= "'s ParamName or ParamValue is null";
		public static final String	MACHINE									= "MACHINE";
		public static final String	MAIN									= "MAIN";
		public static final String	UNIT									= "UNIT";
		public static final String	DURABLELIST								= "DURABLELIST";
		public static final String	TRAYQTY									= "TRAYQTY";
		public static final String	LOTQRY									= "LOTQRY";
		public static final String	old										= "old";
		public static final String	event									= "event";
		public static final String	last									= "last";
		public static final String	timekey									= "timekey";
		public static final String	lastEventTimeKey						= "lastEventTimeKey";
		public static final String	falses									= "false";
		public static final String	trues									= "true";
		public static final String	SOURCEMACHINENAME						= "SOURCEMACHINENAME";
		public static final String	SOURCEPOSITIONNAME						= "SOURCEPOSITIONNAME";
		public static final String	TARGETMACHINENAME						= "TARGETMACHINENAME";
		public static final String	Command									= "Command";
		public static final String	Suffix_bpel								= ".bpel";
		public static final String	Successful								= "Successful";
		public static final String	ECC										= "ECC";
		public static final String	B11MES									= "B11MES";
		public static final String	MaterialType							= "MaterialType";
		public static final String	MaterialName							= "MaterialName";
		public static final String	Weight									= "Weight";
		public static final String	OutBoxName								= "OutBoxName";
		public static final String	OutBoxNameEAC2							= "OutBoxNameEAC2";
		public static final String	ProductSize								= "ProductSize";
		public static final String	SHOP									= "SHOP";
		public static final String	MATERIALCODE							= "MATERIALCODE";
		public static final String	GWVALUE									= "GWVALUE";
		public static final String	PCVALUE									= "PCVALUE";
		public static final String	MCVALUE									= "MCVALUE";
		public static final String	VDVALUE									= "VDVALUE";
		public static final String	DCVALUE									= "DCVALUE";
		public static final String	THREEZEROFILL							= "%03d";
		public static final String	RECIPENAME								= "RECIPENAME";
		public static final String	LABELTYPE								= "LABELTYPE";
		public static final String	NORMAL									= "NORMAL";
		public static final String	PROCESSGROUPNAMELIST					= "PROCESSGROUPNAMELIST";
		public static final String	PRODUCTREQUESTNAME						= "PRODUCTREQUESTNAME";
		public static final String	SUPERPROCESSGROUPNAME					= "SUPERPROCESSGROUPNAME";
		public static final String	PALLETNAME								= "PALLETNAME";
		public static final String	LINENAME								= "LINENAME";
		public static final String	ACTIONFLAG								= "ACTIONFLAG";
		public static final String	ACTION									= "ACTION";
		public static final String	AREANAME								= "AREANAME";
		public static final String	DeassignFlag							= "DeassignFlag";
		public static final String	ADDEDQTY								= "ADDEDQTY";
		public static final String	BEFOREPRODUCTSPECNAME					= "BEFOREPRODUCTSPECNAME";
		public static final String	POSITIONGROUP							= "POSITIONGROUP";
		public static final String	MAXSEQ									= "MAXSEQ";
		public static final String	EMPTY									= "EMPTY";
		public static final String	AUFNR									= "AUFNR";
		public static final String	RESULTCODE								= "RESULTCODE";
		public static final String	RESULTMESSAGE							= "RESULTMESSAGE";
		public static final String	tableName								= "tableName";
		public static final String	erpTable								= "erpTable";
		public static final String	CONDATE									= "CONDATE";
		public static final String	CONTIME									= "CONTIME";
		public static final String	GAMNG									= "GAMNG";
		public static final String	COLUMNNAME								= "COLUMNNAME";
		public static final String	DLVST									= "DLVST";
		public static final String	FLAG									= "FLAG";
		public static final String	MATERCODE							    = "MATERCODE";
		public static final String	PLANQUANTITY							= "PLANQUANTITY";
		public static final String	PLANRELEASEDTIME						= "PLANRELEASEDTIME";
		public static final String	PLANFINISHEDTIME						= "PLANFINISHEDTIME";
		public static final String	PRODUCTREQUESTTYPE						= "PRODUCTREQUESTTYPE";
		public static final String	ZCOMMENT								= "ZCOMMENT";
		public static final String	REL										= "REL";
		public static final String	WORKORDERNAME							= "WORKORDERNAME";
		public static final String	WORKORDER							= "WORKORDER";
		public static final String	TECO									= "TECO";
		public static final String	DLV										= "DLV";
		public static final String	CHAG									= "CHAG";
		public static final String	YMSTIMEKEY								= "YMSTIMEKEY";
		public static final String	YMSTIME									= "YMSTIME";
		public static final String	JUDGE									= "JUDGE";
		public static final String	JUDGETYPE								= "JUDGETYPE";
		public static final String	LOADFLAG								= "LOADFLAG";
		public static final String	CONSUMQTY								= "CONSUMQTY";
		public static final String	MODULERECEIVEDFLAG						= "MODULERECEIVEDFLAG";
		public static final String	SubjectName_							= "SubjectName_";
		public static final String	COMMUNICATIONSTATE						= "COMMUNICATIONSTATE";
		public static final String	SERVICENAME								= "SERVICENAME";
		public static final String	EMPTYBOXID								= "EMPTYBOXID";
		public static final String	EMPTYCURRENTWEIGHT						= "EMPTYCURRENTWEIGHT";
		public static final String	BOXQTY									= "BOXQTY";
		public static final String	BOXWEIGHT								= "BOXWEIGHT";
		public static final String	DIVISION1								= "DIVISION1";
		public static final String	DIVISION2								= "DIVISION2";
		public static final String	VALUE									= "VALUE";
		public static final String	BOXWEIGHT_FACTOR						= "BOXWEIGHT_FACTOR";
		public static final String	SPACERWEIGHT							= "SPACERWEIGHT";
		public static final String	SPACERWEIGHT_FACTOR						= "SPACERWEIGHT_FACTOR";
		public static final String	BOXWEIGHTBYQUANTITY						= "BOXWEIGHTBYQUANTITY";
		public static final String	MAXWEIGHT_								= "MAXWEIGHT_";
		public static final String	MINWEIGHT_								= "MINWEIGHT_";
		public static final String	AddData									= "AddData";
		public static final String	WEIGHTSPECNAME							= "WEIGHTSPECNAME";
		public static final String	PPIDCHANGEFLAG					   		= "PPIDCHANGEFLAG";
		public static final String	RECIPECHECKFLAG							= "RECIPECHECKFLAG";
		public static final String	RMSRESULT					    	    = "RMSRESULT";
		public static final String	FACTORY									= "FACTORY";
		public static final String	WEIGHTSPECVERSION						= "WEIGHTSPECVERSION";
		public static final String	MINWEIGHT								= "MINWEIGHT";
		public static final String	MAXWEIGHT								= "MAXWEIGHT";
		public static final String	ModifyData								= "ModifyData";
		public static final String	NEWMINWEIGHT							= "NEWMINWEIGHT";
		public static final String	NEWMAXWEIGHT							= "NEWMAXWEIGHT";
		public static final String	Modify									= "Modify";
		public static final String	DeleteData								= "DeleteData";
		public static final String	RECEIVETYPE								= "RECEIVETYPE";
		public static final String	RECEIVEFROM								= "RECEIVEFROM";
		public static final String	LOTCANCELEDTIMEKEY						= "LOTCANCELEDTIMEKEY";
		public static final String	PRODUCTQUANTITY							= "PRODUCTQUANTITY";
		public static final String	CELLLOTNAME								= "CELLLOTNAME";
		public static final String	MODULEWORKORDER							= "MODULEWORKORDER";
		public static final String	LOTABORTFLAG							= "LOTABORTFLAG";
		public static final String	MESRECEIVEFLAG							= "MESRECEIVEFLAG";
		public static final String	RECEIVEDFROM							= "RECEIVEDFROM";
		public static final String	PACKINGSTATE							= "PACKINGSTATE";
		public static final String	STOCKSTATE								= "STOCKSTATE";
		public static final String	SITENAME								= "SITENAME";
		public static final String	PRODUCTPACKINGNAME						= "PRODUCTPACKINGNAME";
		public static final String	POSITIONNAME							= "POSITIONNAME";
		public static final String	BOXNAME									= "BOXNAME";
		public static final String	INVOICENAME								= "INVOICENAME";
		public static final String	ERPLOCATION								= "ERPLOCATION";
		public static final String	RECEIVEACTNO							= "RECEIVEACTNO";
		public static final String	MODOQALOTNAME							= "MODOQALOTNAME";
		public static final String	AREATYPE				       			= "AREATYPE";
		public static final String	AREANO				        			= "AREANO";
		public static final String	FLOOR			       		         	= "FLOOR";
		
		
		public static final String	CONSUMABLESPEC							= "CONSUMABLESPEC";	
		public static final String	MATERIALQUANTITY						= "MATERIALQUANTITY";
		public static final String	PRODUCTQTY								= "PRODUCTQTY";
		public static final String	BEFOREFACTORYNAME						= "BEFOREFACTORYNAME";
		public static final String	BEFOREPROCESSOPERATIONNAME				= "BEFOREPROCESSOPERATIONNAME";
		public static final String	BEFORESEQUENCEID						= "BEFORESEQUENCEID";
		public static final String	MODULERECEIVEFLAG						= "MODULERECEIVEFLAG";
		public static final String	BSFGMSLOTService						= "BSFGMSLOTService";
		public static final String	BSFGMSPROCESSGROUPService				= "BSFGMSPROCESSGROUPService";
		public static final String	CLEARUSER								= "CLEARUSER";
		public static final String	ALARMREASON								= "ALARMREASON";
		public static final String	USERMEASURES							= "USERMEASURES";
		public static final String	REASONCODETYPE							= "REASONCODETYPE";
		public static final String	REASONCODEGROUP							= "REASONCODEGROUP";
		public static final String	REASONCODESUBGROUP						= "REASONCODESUBGROUP";
		public static final String	REASONCODE								= "REASONCODE";
		public static final String	PRODUCT									= "PRODUCT";
		public static final String	PRODUCTTYPE								= "PRODUCTTYPE";
		public static final String	DCDATAID								= "DCDATAID";
		public static final String	ALARMACTIONCODE							= "ALARMACTIONCODE";
		public static final String	ALARMTYPE								= "ALARMTYPE";
		public static final String	ExtendedC								= "ExtendedC";
		public static final String	PRODUCTCODE								= "PRODUCTCODE";
		public static final String	RELEASEDQUANTITY						= "RELEASEDQUANTITY";
		public static final String	QUERYID									= "QUERYID";
		public static final String	VERSION									= "VERSION";
		public static final String	QUERYSTRING								= "QUERYSTRING";
		public static final String	NEWPRODUCTREQUESTNAME					= "NEWPRODUCTREQUESTNAME";
		public static final String	MACHINESTATENAME						= "MACHINESTATENAME";
		public static final String	MACHINESUBSTATENAME						= "MACHINESUBSTATENAME";
		public static final String	PORT									= "PORT";
		public static final String	STATEMODEL								= "STATEMODEL";
		public static final String	OLDSTATENAME							= "OLDSTATENAME";
		public static final String	NEWSTATENAME							= "NEWSTATENAME";
		public static final String	CONDITIONID								= "CONDITIONID";
		public static final String	NECESSARYTIME							= "NECESSARYTIME";
		public static final String	BSMACHINESTATECHANGELISTService			= "BSMACHINESTATECHANGELISTService";
		public static final String	BSRECEIVEMATERIALQTYService				= "BSRECEIVEMATERIALQTYService";
		public static final String	BSLOCATIONCONSUMABLESPECQTYService		= "BSLOCATIONCONSUMABLESPECQTYService";
		public static final String	BSLOCATIONCONSUMABLESPECQTYHISService	= "BSLOCATIONCONSUMABLESPECQTYHISService";
		public static final String	STATENAME								= "STATENAME";
		public static final String	FABSTATENAME							= "FABSTATENAME";
		public static final String	NEWVERSION								= "NEWVERSION";
		public static final String	NEWDESCRIPTION							= "NEWDESCRIPTION";
		public static final String	PORTACCESSMODE							= "PORTACCESSMODE";
		public static final String	PORTTYPE								= "PORTTYPE";
		public static final String	PORTUSETYPE								= "PORTUSETYPE";
		public static final String	LINENO									= "LINENO";
		public static final String	LINETYPE								= "LINETYPE";
		public static final String	BEFOREMACHINENAME						= "BEFOREMACHINENAME";
		public static final String	BEFOREOPERATION							= "BEFOREOPERATION";
		public static final String	SPCCONTROLRULENAME						= "SPCCONTROLRULENAME";
 		public static final String	USL										= "USL";
		public static final String	LSL										= "LSL";
		public static final String	SITEVALUE								= "SITEVALUE";
		public static final String	UPPERLIMIT								= "UPPERLIMIT";
		public static final String	LOWERLIMIT								= "LOWERLIMIT";
		public static final String	DEFECTCOUNT								= "DEFECTCOUNT";
		public static final String	AVG										= "AVG";
		public static final String	RANGE									= "RANGE";
		public static final String	MAX										= "MAX";
		public static final String	MIN										= "MIN";
		public static final String	CHARTNAME								= "CHARTNAME";
		public static final String	STD										= "STD";
		public static final String	SPCCONTROLSPECNAME						= "SPCCONTROLSPECNAME";
		public static final String	ITEMNAME								= "ITEMNAME";
		public static final String	Item									= "Item";	
		public static final String	SUPERITEMNAME							= "SUPERITEMNAME";	
		public static final String	MACHINEGROUPNAME						= "MACHINEGROUPNAME";	
		public static final String	UNITTYPE								= "UNITTYPE";	
		public static final String	ITEMTYPE								= "ITEMTYPE";	
		public static final String	DCTYPE									= "DCTYPE";
	
		
		public static final String	CONTROLID								= "CONTROLID";
		public static final String	DETAILPROCESSOPERATIONGROUP				= "DETAILPROCESSOPERATIONGROUP";
		public static final String	PanelList								= "PanelList";
		public static final String	MATERIALBOMSIZE							= "MATERIALBOMSIZE";
		public static final String	Serial									= "Serial";
		public static final String	STARTTIME								= "STARTTIME";
		public static final String	ENDTIME									= "ENDTIME";
		public static final String	LASTCOMMENT								= "LASTCOMMENT";
		public static final String	LASTEVENTTIME							= "LASTEVENTTIME";
		public static final String	SUMQUANTITY								= "SUMQUANTITY";
		public static final String	PRIORITY								= "PRIORITY";
		public static final String	DETAILPOERATIONGROUP					= "DETAILPOERATIONGROUP";
		public static final String	TOPROCESSOPERATIONNAME					= "TOPROCESSOPERATIONNAME";
		public static final String	DEFAULTAREANAME							= "DEFAULTAREANAME";
		public static final String	DETAILMATERIALTYPE						= "DETAILMATERIALTYPE";
		public static final String	LOTSHAPE								= "LOTSHAPE";
		public static final String	substr									= "substr";
		public static final String	Numeric									= "Numeric";
		public static final String	AlphaNumeric1st36Notation				= "AlphaNumeric1st36Notation";
		public static final String	AlphaNumeric1st36NotationExA00			= "AlphaNumeric1st36NotationExA00";
		public static final String	AlphaNumeric1st_Floor2					= "AlphaNumeric1st_Floor2";
		public static final String	AlphaNumeric1st_Floor4					= "AlphaNumeric1st_Floor4";
		public static final String	AlphaNumericNotation					= "AlphaNumericNotation";
		public static final String	AlphaNumericNotationExA00				= "AlphaNumericNotationExA00";
		public static final String	Alpha									= "Alpha";
		public static final String	REVISIONCODE							= "REVISIONCODE";
		public static final String	FA										= "FA";
		public static final String	RECEIVEDUSEFLAG							= "RECEIVEDUSEFLAG";
		public static final String	LOCATIONNAME							= "LOCATIONNAME";
		public static final String	BSTPFOCONSUMABLESPEC					= "BSTPFOCONSUMABLESPEC";
		public static final String	SUPERAREANAME							= "SUPERAREANAME";
		public static final String	MATERIALLOCATIONNAME					= "MATERIALLOCATIONNAME";
		public static final String	PACKINGTYPE								= "PACKINGTYPE";
		public static final String	Box										= "Box";
		public static final String	MATERIALTYPE							= "MATERIALTYPE";
		public static final String	MATERIALNAME							= "MATERIALNAME";
		public static final String	PACKINGGRADE							= "PACKINGGRADE";
		public static final String	FROMDATE								= "FROMDATE";
		public static final String	TODATE									= "TODATE";
		public static final String	PRODUCTHOLDSTATE						= "PRODUCTHOLDSTATE";
		public static final String	LOTTYPE									= "LOTTYPE";
		public static final String	TRAYID									= "TRAYID";
		public static final String	PANELPOSITION							= "PANELPOSITION";
		public static final String	CONSUMABLESTATE							= "CONSUMABLESTATE";
		public static final String	LOTNAMES								= "LOTNAMES";
		public static final String	LotGrade_Cell_Grade						= "LotGrade_Cell_Grade";
		public static final String	GRADE									= "GRADE";
		public static final String	RESERVEHOLDINMODULEFLAG					= "RESERVEHOLDINMODULEFLAG";
		public static final String	INVOICENO								= "INVOICENO";
		public static final String	ORDERNO									= "ORDERNO";
		public static final String	RECEIVEUSER								= "RECEIVEUSER";
		public static final String	RECEIVETIMEKEY							= "RECEIVETIMEKEY";
		public static final String	PACKINGUSER								= "PACKINGUSER";
		public static final String	PACKINGTIMEKEY							= "PACKINGTIMEKEY";
		public static final String	SHIPPINGTIMEKEY							= "SHIPPINGTIMEKEY";
		public static final String	MODULEFGCODE							= "MODULEFGCODE";
		public static final String	MODULESTARTTIMEKEY						= "MODULESTARTTIMEKEY";
		public static final String	HOLDFLAG								= "HOLDFLAG";
		public static final String	HOLDSTATE								= "HOLDSTATE";
		public static final String	BACKSHIPPINGFLAG						= "BACKSHIPPINGFLAG";
		public static final String	RECIPEPARAMETERNAME						= "RECIPEPARAMETERNAME";
		public static final String	Delete									= "Delete";
		public static final String	Change									= "Change";
		public static final String	Create									= "Create";
		public static final String	BSRESERVEMACHINEService					= "BSRESERVEMACHINEService";
		public static final String	createReserveMachine					= "createReserveMachine";
		public static final String	BSRESERVEPRODUCTSPECService				= "BSRESERVEPRODUCTSPECService";
		public static final String	BSCOMPONENTHISTORYService				= "BSCOMPONENTHISTORYService";
		public static final String	BSMATCOMPONENTHISTORYService			= "BSMATCOMPONENTHISTORYService";
		public static final String	BSTIMEACTIONService						= "BSTIMEACTIONService";		
		public static final String	BSTRANSPORTJOBCOMMANDService			= "BSTRANSPORTJOBCOMMANDService";
		public static final String	createReserveProductSpec				= "createReserveProductSpec";
		public static final String	BSRESERVELOTService						= "BSRESERVELOTService";
		public static final String	BSRESERVELOTHistoryService				= "BSRESERVELOTHistoryService";
		public static final String	BSRESERVEPOService						= "BSRESERVEPOService";
		public static final String	BSRESERVEPOHistoryService				= "BSRESERVEPOHistoryService";//
		
		public static final String  PPID                                    = "PPID"; //yk EVTRACKINMACHINENAME
		public static final String  BL                                      = "BL";   
		public static final String  PCB                                     = "PCB";  
		public static final String  IC                                     = "IC";  
		public static final String  BLU                                     = "BLU";  
		
		public static final String	TRAYGROUPID								= "TRAYGROUPID";
		public static final String	BOXID									= "BOXID";
		public static final String	PANELQUANTITY							= "PANELQUANTITY";
		public static final String	TRAYPOSITION							= "TRAYPOSITION";
		public static final String	QUANTITY								= "QUANTITY";
		public static final String	OLDQUANTITY								= "OLDQUANTITY";
		public static final String	PRODUCTSIZE								= "PRODUCTSIZE";
		public static final String	FGMSSTOCKINFLAG							= "FGMSSTOCKINFLAG";
		public static final String	OIC_MOD									= "OIC_MOD";
		public static final String	svr										= "svr";
		public static final String	REQUESTED								= "REQUESTED";
		public static final String	TERMINATED								= "TERMINATED";
		public static final String	makeTransferCommandState				= "makeTransferCommandState";
		public static final String	SharedMachine							= "SharedMachine";
		public static final String	createTransferCommand					= "createTransferCommand";
		public static final String	Durable									= "Durable";
		public static final String	TRANSFERJOBNAME							= "TRANSFERJOBNAME";
		public static final String	TRANSPORTJOBNAME						= "TRANSPORTJOBNAME";
		public static final String	TEMP_									= "TEMP-";
		public static final String	DESTINATIONPOSITIONTYPE					= "DESTINATIONPOSITIONTYPE";
		public static final String	DESTINATIONZONENAME						= "DESTINATIONZONENAME";
		public static final String	CURRENTMACHINENAME						= "CURRENTMACHINENAME";
		public static final String	CURRENTPOSITIONTYPE						= "CURRENTPOSITIONTYPE";
		public static final String	CURRENTPOSITIONNAME						= "CURRENTPOSITIONNAME";
		public static final String	CURRENTZONENAME							= "CURRENTZONENAME";
		public static final String	TRANSPORTJOBSTATE						= "TRANSPORTJOBSTATE";
		public static final String	TRANSPORTJOBTYPE						= "TRANSPORTJOBTYPE";
		public static final String	LASTEVENTRESULTCODE						= "LASTEVENTRESULTCODE";
		public static final String	LASTEVENTRESULTTEXT						= "LASTEVENTRESULTTEXT";
		public static final String	TEMP									= "TEMP";
		public static final String	notChanged								= "notChanged";
		public static final String	COMPLETED								= "COMPLETED";
		public static final String	CARRIERSTATE							= "CARRIERSTATE";
		public static final String	MACHINECONTROLSTATE						= "MACHINECONTROLSTATE";
		public static final String	MCSSTATE								= "MCSSTATE";
		public static final String	MCSNAME									= "MCSNAME";
		public static final String	FROMMACHINENAME							= "FROMMACHINENAME";
		public static final String	FROMPORTNAME							= "FROMPORTNAME";
		public static final String	TOMACHINENAME							= "TOMACHINENAME";
		public static final String	TOPORTNAME								= "TOPORTNAME";
		public static final String	ZONENAME								= "ZONENAME";
		public static final String	COMMAND01								= "COMMAND01";
		public static final String	COMMAND02								= "COMMAND02";
		public static final String	COMMAND03								= "COMMAND03";
		public static final String	COMMAND04								= "COMMAND04";
		public static final String	NoCST									= "NoCST";
		public static final String	NoSourceMachine							= "NoSourceMachine";
		public static final String	NoDestinationMachine					= "NoDestinationMachine";
		public static final String	TIME_DIFFERENCE							= "TIME_DIFFERENCE";
		public static final String	NoPortReadyToLoad						= "NoPortReadyToLoad";
		public static final String	NoPort									= "NoPort";
		public static final String	durableHoldState						= "durableHoldState";
		public static final String	durableState							= "durableState";
		public static final String	FULLSTATE								= "FULLSTATE";
		public static final String	idmDSP									= "idmDSP";
		public static final String	now										= "now";
		public static final String	SUCCESS									= "SUCCESS";
		public static final String	ALTERNATEFLAG							= "ALTERNATEFLAG";
		public static final String	TRANSFERSTATE							= "TRANSFERSTATE";
		public static final String	SOURCEPOSITIONTYPE						= "SOURCEPOSITIONTYPE";
		public static final String	SOURCEZONENAME							= "SOURCEZONENAME";
		public static final String	REQUESTSUBJECTNAME						= "REQUESTSUBJECTNAME";
		public static final String	COLUMN_NAME								= "COLUMN_NAME";
		public static final String	SHUTTLENAME								= "SHUTTLENAME";
		public static final String	SK										= "SK";
		public static final String	OVER									= "OVER";
		public static final String	over1									= "over1";
		public static final String	over2									= "over2";
		public static final String	over3									= "over3";
		public static final String	BLOCKINLINE								= "BLOCKINLINE";
		public static final String	VCRPRODUCTNAME							= "VCRPRODUCTNAME";
		public static final String	MSGSVR									= "MSGSVR";
		public static final String	MATERIALPACKINGNAME						= "MATERIALPACKINGNAME";
		public static final String	MATERIALSPECNAME						= "MATERIALSPECNAME";
		public static final String  MATERIALVERSION                         = "MATERIALVERSION";
		public static final String  MATERIALCONFIG                          = "MATERIALCONFIG";
		public static final String  REQUIREDQUANTITY                        = "REQUIREDQUANTITY";
		public static final String  ISMAINFLAG                              = "ISMAINFLAG";
		public static final String  SUPERMATERIALSPECNAME                   = "SUPERMATERIALSPECNAME";
		public static final String	RecipeParameterName						= "RecipeParameterName";
		public static final String	DCSPECNAME								= "DCSPECNAME";
		public static final String	SAMPLETYPE								= "SAMPLETYPE";
		public static final String	SAMPLESITE								= "SAMPLESITE";
		public static final String	FIRST_ARG								= "FIRST_ARG";
		public static final String	SECOND_ARG								= "SECOND_ARG";
		public static final String	OPERATOR								= "OPERATOR";
		public static final String	SITENAMES								= "SITENAMES";
		public static final String	SITECOUNT								= "SITECOUNT";
		public static final String	CanNotFoundQueryID						= "CanNotFoundQueryID";
		public static final String	queryString								= "queryString";
		public static final String	COMMENT									= "COMMENT";
		public static final String	USERPROFILE								= "USERPROFILE";
		public static final String	BACKSHIPPINGTIMEKEY						= "BACKSHIPPINGTIMEKEY";
		public static final String	MACHINEHOLDACTIONFLAG					= "MACHINEHOLDACTIONFLAG";
		public static final String	LOTHOLDACTIONFLAG						= "LOTHOLDACTIONFLAG";
		public static final String	MESSAGEACTIONFLAG						= "MESSAGEACTIONFLAG";
		public static final String	LOTHOLDAFTERTRANSPORT					= "LOTHOLDAFTERTRANSPORT";
		public static final String	OICSEND									= "OICSEND";
		public static final String	EMAIL									= "EMAIL";
		public static final String	MACHINEHOLDCODE							= "MACHINEHOLDCODE";
		public static final String	LOTHOLDCODE								= "LOTHOLDCODE";
		public static final String	BEFOREOPERATIONLOTHOLD					= "BEFOREOPERATIONLOTHOLD";
		public static final String	AUTOCLEARFLAG							= "AUTOCLEARFLAG";
		public static final String	BEFOREOPERATIONNAME						= "BEFOREOPERATIONNAME";
		public static final String	OICAlarmSender							= "OICAlarmSender";
		public static final String	TITLETEXT								= "TITLETEXT";
		public static final String	BODYTEXT								= "BODYTEXT";
		public static final String	EMAILUSERLIST							= "EMAILUSERLIST";
		public static final String	SUBJECT									= "SUBJECT";
		public static final String	EMAILCONTENTS							= "EMAILCONTENTS";
		public static final String	EMAILSENDSTATUS							= "EMAILSENDSTATUS";
		public static final String	EMAILSENDTIMEKEY						= "EMAILSENDTIMEKEY";
		public static final String	FROMUSERNAME							= "FROMUSERNAME";
		public static final String	AUTHUSERNAME							= "AUTHUSERNAME";
		public static final String	FROMUSERMAIL							= "FROMUSERMAIL";
		public static final String	AUTHPWD									= "AUTHPWD";
		public static final String	SMTPHOSTNAME							= "SMTPHOSTNAME";
		public static final String	SMTPPORT								= "SMTPPORT";
		public static final String	CONTROLCHARTTYPE						= "CONTROLCHARTTYPE";
		public static final String	UPPERSPECLIMIT							= "UPPERSPECLIMIT";
		public static final String	LOWERSPECLIMIT							= "LOWERSPECLIMIT";
		public static final String	LOWERCONTROLLIMIT						= "LOWERCONTROLLIMIT";
		public static final String	UPPERCONTROLLIMIT						= "UPPERCONTROLLIMIT";
		public static final String	CENTERLINE								= "CENTERLINE";
		public static final String	SPC										= "SPC";
		public static final String  ETCOut                                  = "ETCOut";
        public static final String  CancelETCOut                            = "CancelETCOut";
		
		public static final String  QUERYSTRINGADD							= "QUERYSTRINGADD";
		public static final String	bindheader								= "bindheader";
		public static final String	bindbody								= "bindbody";
		public static final String	SPCCONTROLRULEOUTITEM					= "SPCCONTROLRULEOUTITEM";
		public static final String	bodyText								= "bodyText";
		public static final String	titleText								= "titleText";
		public static final String	OQALOTNAME								= "OQALOTNAME";
		public static final String	OQARESULT								= "OQARESULT";
		public static final String	Scrap									= "Scrap";
		public static final String	PUNCHCODE								= "PUNCHCODE";
		public static final String	LINECODE								= "LINECODE";
		
		public static final String	STORAGETYPE								= "STORAGETYPE";
		public static final String	TEMPORARYNO								= "TEMPORARYNO";
		public static final String	PUNCHSTATE								= "PUNCHSTATE";
		public static final String	PUNCHINGTIME							= "PUNCHINGTIME";
		public static final String	REPAIRTIME								= "REPAIRTIME";
		public static final String	PUNCHSPEC								= "PUNCHSPEC";
		public static final String	REASON									= "REASON";		
		public static final String	QUALIFIED								= "QUALIFIED";		
		public static final String	LOGINPERSON								= "LOGINPERSON";	
		public static final String	TOTALPUNCHINGTIME						= "TOTALPUNCHINGTIME";	
		public static final String	DATEOFVERIFY							= "DATEOFVERIFY";	
		public static final String	APPLICABLESCOPE							= "APPLICABLESCOPE";	
		public static final String	REPAIRBORROWUNIT						= "REPAIRBORROWUNIT";	
		public static final String	JOBNO									= "JOBNO";	
		public static final String	JOBPERSONNAME							= "JOBPERSONNAME";	
		public static final String	REMAINS									= "REMAINS";	
		public static final String	OUTPUTTYPE								= "OUTPUTTYPE";	
		public static final String	MAINTENANCEFREQUENCY					= "MAINTENANCEFREQUENCY";	
		public static final String	SIGNATUREMAINTENANCE					= "SIGNATUREMAINTENANCE";	
		public static final String	THERECENTREPAIRDATE						= "THERECENTREPAIRDATE";	
		public static final String	OLDLINECODE								= "OLDLINECODE";	
		public static final String	TAG_LOGINPERSON							= "LOGINPERSON";	
		public static final String	MAINTENANCETIMES						= "MAINTENANCETIMES";		
		public static final String	TotalPunchingTime						= "TotalPunchingTime";	
		public static final String	QUANTITYREQUIRED						= "QUANTITYREQUIRED";	
		public static final String	PUNCHSPECTIMELIMIT						= "PUNCHSPECTIMELIMIT";	
		public static final String	PUNCHSPECREPAIRTIMELIMIT				= "PUNCHSPECREPAIRTIMELIMIT";	
		public static final String	FGCODE									= "FGCODE";	
		
		public static final String	APPLICATIONS							= "APPLICATIONS";	
		public static final String	XLOWERLIMIT								= "XLOWERLIMIT";	
		public static final String	XUPPERLIMIT								= "XUPPERLIMIT";	
		public static final String	YUPPERLIMIT								= "YUPPERLIMIT";	
		public static final String	YLOWERLIMIT								= "YLOWERLIMIT";	
		public static final String	XLEFT									= "XLEFT";	
		public static final String	XRIGHT									= "XRIGHT";	
		public static final String	YLEFT									= "YLEFT";	
		public static final String	YRIGHT									= "YRIGHT";	
		public static final String	UALIFIED								= "UALIFIED";	
		public static final String	SUPERBOXNAME							= "SUPERBOXNAME";
		public static final String	BOXTYPE							        = "BOXTYPE";
		public static final String	QPANELQTY							    = "QPANELQTY";
		public static final String	ITEMCODE							    = "ITEMCODE";
		public static final String	Site									= "Site";
		public static final String	TAG_SITECODE							= "SITECODE";
		public static final String	SubjectName_RMS							= "SubjectName_RMS";
		public static final String	xmlData									= "xmlData";
		public static final String	LOTQUANTITY								= "LOTQUANTITY";
		public static final String	CAPACITY								= "CAPACITY";

		
		public static final String  PLANDATE                                = "PLANDATE";
        public static final String  B11                                     = "B11";
        public static final String  OEMSITENAME                             = "OEMSITENAME";
        public static final String  PLAN_IN_QTY                             = "PLAN_IN_QTY";
        public static final String  PLAN_IN_PRIORITY                        = "PLAN_IN_PRIORITY";
        public static final String  PLAN_OUT_QTY                            = "PLAN_OUT_QTY";
        public static final String  PLAN_OUT_PRIORITY                       = "PLAN_OUT_PRIORITY";
        public static final String	TRAYTYPE								= "TRAYTYPE";
        public static final String	OPERATIONMODE							= "OPERATIONMODE";
        public static final String	JIGVERSION								= "JIGVERSION";
        public static final String	PROGRAMVERSION							= "PROGRAMVERSION";
        public static final String	OPERATIONMODEDESCRIPTION				= "OPERATIONMODEDESCRIPTION";       
        public static final String	OPERATIONMODENAME						= "OPERATIONMODENAME";   
        
        public static final String	SPAREPARTCODE							= "SPAREPARTCODE";   
        public static final String	SPAREPARTNAME							= "SPAREPARTNAME"; 
        public static final String	STANDARDFLAG							= "STANDARDFLAG"; 
        public static final String	SPAREPARTTYPE							= "SPAREPARTTYPE"; 
        public static final String	INEVENTTIME							    = "INEVENTTIME"; 
        public static final String	INEVENTUSER							    = "INEVENTUSER"; 
        public static final String	INEVENTCOMMENT							= "INEVENTCOMMENT"; 
        public static final String	OUTEVENTTIME							= "OUTEVENTTIME"; 
        public static final String	OUTEVENTUSER							= "OUTEVENTUSER"; 
        public static final String	OUTEVENTCOMMENT							= "OUTEVENTCOMMENT"; 
        public static final String	DETAILTYPE							    = "DETAILTYPE"; 
        public static final String	TIMEUSEDLIMIT						    = "TIMEUSEDLIMIT";
        public static final String  RTS_PLAN_FLAG							= "RTS_PLAN_FLAG";
        public static final String  PLAN_VERSION_NO    						= "PLAN_VERSION_NO";
        public static final String  PLAN_FACTORYNAME    					= "PLAN_FACTORYNAME";
        public static final String  PLAN_LOTNAME    						= "PLAN_LOTNAME";
        public static final String  PLAN_PRODUCTSPECNAME    				= "PLAN_PRODUCTSPECNAME";
        public static final String  PLAN_PROCESSFLOWNAME    				= "PLAN_PROCESSFLOWNAME";
        public static final String  PLAN_PROCESSOPERATIONNAME 				= "PLAN_PROCESSOPERATIONNAME";
        public static final String  PLAN_MACHINENAME    					= "PLAN_MACHINENAME";
        public static final String  PLAN_TIME    							= "PLAN_TIME";
        public static final String  PLAN_SEQ    							= "PLAN_SEQ";
        public static final String  FPCNAME    						     	= "FPCNAME";
        public static final String  FPCLIST    						     	= "FPCLIST";
        public static final String  PCBNAME    						     	= "PCBNAME";
        public static final String  DSIPNAME    						    = "DSIPNAME";
        public static final String  TCARRIERNAME    					   	= "TCARRIERNAME";
        public static final String  MATERIALCHECKFLAG    				    = "MATERIALCHECKFLAG";
        public static final String	CONSUMABLEQUANTITY						= "CONSUMABLEQUANTITY";
        public static final String  BSCVDATANUMBERService    				= "BSCVDATANUMBERService";
        public static final String  BSCVDATAService    						= "BSCVDATAService";
        public static final String  BSCVDATAITEMService    					= "BSCVDATAITEMService";
        public static final String  ICNAME    					= "ICNAME";
        public static final String  BTBNAME    					= "BTBNAME";
        
        public static final String  GETNLSDATALIST							= "GetNLSDataList";
        
        //BSQUERYMESSAGELOG
        public static final String  ELAPSEDTIME                 			= "ELAPSEDTIME";
        public static final String  ROW_COUNT                 				= "ROW_COUNT";
        public static final String  QRY_ID                 					= "QRY_ID";
        public static final String  QRY_VERSION                 			= "QRY_VERSION";
        public static final String  QRYSTRING                 				= "QRYSTRING";
        
        //panelInfoRequestType
        public static final String  FPC                 					= "FPC";
        public static final String  DSIP                 					= "DSIP";
        public static final String  CUSTOMER                 				= "CUSTOMER";
        public static final String  TCARRIER                 				= "TCARRIER";
        public static final String  ICID                 					= "ICID";
        public static final String  BTBID                 					= "BTBID";
        
        //yzz add
		public static final String	STOKERNAME								= "STOKERNAME";

	}
}

