/*
 ****************************************************************************
 *
 *  (c) Copyright 2013 BOE IDM. All rights reserved.
 *
 *  This software is proprietary to and embodies the confidential
 *  technology of BOE IDM. Possession, use, or copying of this
 *  software and media is authorized only pursuant to a valid written
 *  license from BOE IDM.
 *
 ****************************************************************************
 */

package com.cim.idm.mwmsextend.transport.management.action;

import org.springframework.stereotype.Component;

import com.cim.idm.mwmsextend.transport.management.data.TransportCommand;
import com.cim.idm.mwmsextend.transport.management.data.TransportCommandHistory;
import com.cim.idm.mwmsextend.transport.management.data.TransportCommandKey;
import com.cim.idm.mwmsextend.transport.management.info.SetEventInfo;
import com.cim.idm.wmspackage.action.CommonAction;

/**
 ****************************************************************************
 *  PACKAGE : com.cim.idm.mwmsextend.transport.management.action <br>
 *  NAME    : SetEventAction.java <br>
 *  TYPE    : JAVA <br>
 *  DESCRIPTION :Set the consumable’s event.
 *
 ****************************************************************************
 */
@Component("TransportCommandSetEventAction")
public class SetEventAction extends CommonAction<TransportCommandKey,TransportCommand,TransportCommandHistory,SetEventInfo>
{

}
