package com.cim.idm.mwmsextend.transport.management.impl;

import java.util.List;

import org.springframework.stereotype.Component;

import com.cim.idm.framework.exception.IDMFrameDBErrorSignal;
import com.cim.idm.framework.exception.ext.NotFoundSignal;
import com.cim.idm.framework.orm.service.CommonHistoryServiceDAO;
import com.cim.idm.mwmsextend.transport.management.TransportCommandHistoryService;
import com.cim.idm.mwmsextend.transport.management.data.TransportCommandHistory;
import com.cim.idm.mwmsextend.transport.management.data.TransportCommandHistoryKey;
@Component("transportCommandHistoryService")
public class TransportCommandHistoryServiceImpl
		extends
		CommonHistoryServiceDAO<TransportCommandHistoryKey, TransportCommandHistory>
		implements TransportCommandHistoryService {

	@Override
	public List<TransportCommandHistory> select(String condition, Object[] bindSet) throws NotFoundSignal,IDMFrameDBErrorSignal {
		return this.select(condition, bindSet, TransportCommandHistory.class);
	}

}
