package com.cim.idm.dao;


import com.cim.idm.wmspackage.materialpacking.management.data.MaterialPacking;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;
import org.springframework.stereotype.Component;

import java.util.List;

@Component
@Mapper
public interface FgStockInDao {

    //调用接口查询当前Box是否都是在库需要转库，传入List<MaterialPacking>
    public List<MaterialPacking> getBoxList(@Param("boxList") List<MaterialPacking> boxList,@Param("erpFactory") String erpFactory
    ,@Param("erpLocation") String erpLocation,@Param("locationName") String locationName) throws Exception;

    //批量更新BS_MES_SHIPPED表的ReceiveFlag和ReceiveTime
    public void updateBsMesShipped(@Param("boxList") List<MaterialPacking> boxList) throws Exception;
}
