package com.cim.idm.model;

import com.cim.idm.framework.orm.info.DataInfo;
import com.cim.idm.framework.orm.info.access.FieldAccessor;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;

import java.sql.Timestamp;

@Data
@EqualsAndHashCode(callSuper = false)
@NoArgsConstructor
public class BSLabel extends FieldAccessor implements DataInfo<BSLabelKey>{
	private BSLabelKey key;
	
	private String labelType;
	private String labelGroup;
	private String labelDrive;
	private String labelName;
	private String labelAddress;
	private String description;
	private String server;
	private String createUser;
	private Timestamp createTime;
	private String lastEventUser;
	private String lastEventName;
	private String lastEventTimeKey;
	private String lastEventComment;
	private Timestamp lastEventTime;
	private Timestamp effectiveDate;
	private Timestamp dueDate;
}
