package com.cim.idm.model;

import lombok.Data;

import java.util.List;

@Data
public class BarcodeListByInvoice {

    private String siteName;

    private String userId;

    private String receiveRequestName;

    private String receiveReqeustDetailName;

    private String shipRequestName;

    private String shipRequestDetailName;

    private String erpFactory;

    private String erpLocation;

    private String locationName;

    private String opType;

    private List<Barcode> boxList;


    @Data
    public static class Barcode {

        private String materialPackingName;

        private String locationName;

        private String siteName;
    }
}
