package com.cim.idm.model;

import lombok.Data;
import lombok.NoArgsConstructor;

@Data
@NoArgsConstructor
public class LabelPrintDto2 {

    // 标签信息
    //@Schema(description = "标签ID", example = "123456", required = true)
    private String labelId;

    //@Schema(description = "标签类型", example = "TypeA", required = true)
    private String labelType;

    //@Schema(description = "标签组", example = "GroupX")
    private String labelGroup;

    //@Schema(description = "标签驱动", example = "DriveZ")
    private String labelDrive;

    //@Schema(description = "标签名称", example = "我的标签", required = true)
    private String labelName;

    //@Schema(description = "标签地址", example = "123 Main St.")
    private String labelAddress;

    //@Schema(description = "标签描述", example = "标签的详细描述")
    private String description;

    //@Schema(description = "关联服务器", example = "server01.example.com")
    private String server;

    // 打印数据ID
    //@Schema(description = "标签打印输入ID", example = "input_abc", required = true)
    private String inputId;

    // 标签打印信息
    //@Schema(description = "打印机名称", example = "HP LaserJet Pro")
    private String printerName;

    //@Schema(description = "打印数量", example = "50", type = "integer", minimum = "1")
    private String printerQty;

    //@Schema(description = "产品规格名称", example = "产品A")
    private String productSpecName;

    //@Schema(description = "序列号（逗号分隔）", example = "SN123, SN456, SN789")
    private String serialNumbers;

    //@Schema(description = "批次号", example = "SH0000001",required = true)
    private String lotName;
    
    //@Schema(description = "操作人", example = "101867",required = true)
    private String opreater;
    
    //@Schema(description = "数量", example = "101867",required = true)
    private String qty;
    
}
