/*
 ****************************************************************************
 *
 *  (c) Copyright 2013 BOE IDM. All rights reserved.
 *
 *  This software is proprietary to and embodies the confidential
 *  technology of BOE IDM. Possession, use, or copying of this
 *  software and media is authorized only pursuant to a valid written
 *  license from BOE IDM.
 *
 ****************************************************************************
 */
package com.cim.idm.service;

import com.cim.idm.framework.data.EventInfo;
import com.cim.idm.framework.exception.IDMFrameDBErrorSignal;
import com.cim.idm.model.LabelPrintInfo;

import java.util.List;

/**
 * @Class com.zisemi.mes.solution.service.management.LabelPrintInfoService<br/>
 * @Description LabelPrintInfoService.
 * @author 10781388
 * @Time 2024-04-29 10:14:12
 */
public interface LabelPrintInfoService {

	public List<LabelPrintInfo> select(String condition, Object[] bindSet) throws IDMFrameDBErrorSignal;

	public LabelPrintInfo selectByKey(boolean isLock, Object[] keySet) throws IDMFrameDBErrorSignal;

	public LabelPrintInfo create(EventInfo eventInfo, LabelPrintInfo dataInfo) throws IDMFrameDBErrorSignal;

	public void remove(EventInfo eventInfo, LabelPrintInfo dataInfo) throws IDMFrameDBErrorSignal;

	public LabelPrintInfo modify(EventInfo eventInfo, LabelPrintInfo dataInfo) throws IDMFrameDBErrorSignal;

}
