package com.cim.idm.service;

import java.util.List;
import java.util.Map;

public interface SaleReturnService {

	/**
	 * 调拨入库绑条码
	 * @param materialspecName
	 * @param charge
	 * @param materialspecName1
	 * @param user
	 * @param shipRequestName
	 * @param shipRequestDetailName
	 * @param locationName
	 * @return
	 * @throws Exception
	 */
	public boolean BindBarCodeToSaleReturn (String materialspecName,String charge,String materialspecName1,String user,
			String shipRequestName,String shipRequestDetailName,String locationName) throws Exception;

	/**
	 * 退货绑定条码
	 * @param materialSpecName
	 * @param phase
	 * @param map
	 * @param materialQuantity
	 * @param materialPackingName
	 * @param user
	 * @param erpFactory
	 * @param erpLocation
	 * @param locationName
	 * @param shipRequestName
	 * @param charge
	 * @return
	 * @throws Exception
	 */
	public boolean BindBarProductSaleReturn (String materialSpecName,String phase,List<Map<String, Object>> map,String materialQuantity,String materialPackingName,
			String user,String erpFactory,String erpLocation,String locationName,String shipRequestName,String charge) throws Exception;
	
	/**
	 * 销售退货提交
	 * @param shipRequestName
	 * @param user
	 * @param commitDate
	 * @return
	 * @throws Exception
	 */
	public boolean CommitSaleReturnInvoice (
			String shipRequestName,String user,String commitDate,String opcode) throws Exception;
}
