package com.cim.idm.mwmsextend.transport.management.impl;

import java.util.List;

import org.springframework.stereotype.Service;

import com.cim.idm.framework.exception.IDMFrameDBErrorSignal;
import com.cim.idm.framework.exception.ext.NotFoundSignal;
import com.cim.idm.framework.orm.service.CommonHistoryServiceDAO;
import com.cim.idm.mwmsextend.transport.management.TransportCommandDetailHistoryService;
import com.cim.idm.mwmsextend.transport.management.data.TransportCommandDetailHistory;
import com.cim.idm.mwmsextend.transport.management.data.TransportCommandDetailHistoryKey;
@Service("transportCommandDetailHistoryService")
public class TransportCommandDetailHistoryServiceImpl
		extends
		CommonHistoryServiceDAO<TransportCommandDetailHistoryKey, TransportCommandDetailHistory>
		implements TransportCommandDetailHistoryService {

	@Override
	public List<TransportCommandDetailHistory> select(String condition, Object[] bindSet) throws NotFoundSignal,IDMFrameDBErrorSignal {
		return this.select(condition, bindSet, TransportCommandDetailHistory.class);
	}

}
